diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/wifi/model/wifi-ppdu.cc ns-3.32/src/wifi/model/wifi-ppdu.cc
--- ns-3.31/src/wifi/model/wifi-ppdu.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/wifi/model/wifi-ppdu.cc	2020-10-06 15:35:43.000000000 -0700
@@ -29,12 +29,12 @@
 
 NS_LOG_COMPONENT_DEFINE ("WifiPpdu");
 
-WifiPpdu::WifiPpdu (Ptr<const WifiPsdu> psdu, WifiTxVector txVector, Time ppduDuration, uint16_t frequency)
+WifiPpdu::WifiPpdu (Ptr<const WifiPsdu> psdu, WifiTxVector txVector, Time ppduDuration, WifiPhyBand band)
   : m_preamble (txVector.GetPreambleType ()),
     m_modulation (txVector.IsValid () ? txVector.GetMode ().GetModulationClass () : WIFI_MOD_CLASS_UNKNOWN),
     m_psdu (psdu),
     m_truncatedTx (false),
-    m_frequency (frequency),
+    m_band (band),
     m_channelWidth (txVector.GetChannelWidth ()),
     m_txPowerLevel (txVector.GetTxPowerLevel ())
 {
@@ -42,7 +42,7 @@
     {
       return;
     }
-  NS_LOG_FUNCTION (this << psdu << txVector << ppduDuration << frequency);
+  NS_LOG_FUNCTION (this << psdu << txVector << ppduDuration << band);
   switch (m_modulation)
     {
       case WIFI_MOD_CLASS_DSSS:
@@ -63,7 +63,7 @@
       case WIFI_MOD_CLASS_HT:
         {
           uint8_t sigExtension = 0;
-          if (Is2_4Ghz (frequency))
+          if (m_band == WIFI_PHY_BAND_2_4GHZ)
             {
               sigExtension = 6;
             }
@@ -95,7 +95,7 @@
       case WIFI_MOD_CLASS_HE:
         {
           uint8_t sigExtension = 0;
-          if (Is2_4Ghz (frequency))
+          if (m_band == WIFI_PHY_BAND_2_4GHZ)
             {
               sigExtension = 6;
             }
@@ -290,110 +290,7 @@
         }
       case WIFI_MOD_CLASS_HT:
         {
-          WifiMode mode;
-          switch (m_htSig.GetMcs ())
-            {
-              case 0:
-                mode = WifiPhy::GetHtMcs0 ();
-                break;
-              case 1:
-                mode = WifiPhy::GetHtMcs1 ();
-                break;
-              case 2:
-                mode = WifiPhy::GetHtMcs2 ();
-                break;
-              case 3:
-                mode = WifiPhy::GetHtMcs3 ();
-                break;
-              case 4:
-                mode = WifiPhy::GetHtMcs4 ();
-                break;
-              case 5:
-                mode = WifiPhy::GetHtMcs5 ();
-                break;
-              case 6:
-                mode = WifiPhy::GetHtMcs6 ();
-                break;
-              case 7:
-                mode = WifiPhy::GetHtMcs7 ();
-                break;
-              case 8:
-                mode = WifiPhy::GetHtMcs8 ();
-                break;
-              case 9:
-                mode = WifiPhy::GetHtMcs9 ();
-                break;
-              case 10:
-                mode = WifiPhy::GetHtMcs10 ();
-                break;
-              case 11:
-                mode = WifiPhy::GetHtMcs11 ();
-                break;
-              case 12:
-                mode = WifiPhy::GetHtMcs12 ();
-                break;
-              case 13:
-                mode = WifiPhy::GetHtMcs13 ();
-                break;
-              case 14:
-                mode = WifiPhy::GetHtMcs14 ();
-                break;
-              case 15:
-                mode = WifiPhy::GetHtMcs15 ();
-                break;
-              case 16:
-                mode = WifiPhy::GetHtMcs16 ();
-                break;
-              case 17:
-                mode = WifiPhy::GetHtMcs17 ();
-                break;
-              case 18:
-                mode = WifiPhy::GetHtMcs18 ();
-                break;
-              case 19:
-                mode = WifiPhy::GetHtMcs19 ();
-                break;
-              case 20:
-                mode = WifiPhy::GetHtMcs20 ();
-                break;
-              case 21:
-                mode = WifiPhy::GetHtMcs21 ();
-                break;
-              case 22:
-                mode = WifiPhy::GetHtMcs22 ();
-                break;
-              case 23:
-                mode = WifiPhy::GetHtMcs23 ();
-                break;
-              case 24:
-                mode = WifiPhy::GetHtMcs24 ();
-                break;
-              case 25:
-                mode = WifiPhy::GetHtMcs25 ();
-                break;
-              case 26:
-                mode = WifiPhy::GetHtMcs26 ();
-                break;
-              case 27:
-                mode = WifiPhy::GetHtMcs27 ();
-                break;
-              case 28:
-                mode = WifiPhy::GetHtMcs28 ();
-                break;
-              case 29:
-                mode = WifiPhy::GetHtMcs29 ();
-                break;
-              case 30:
-                mode = WifiPhy::GetHtMcs30 ();
-                break;
-              case 31:
-                mode = WifiPhy::GetHtMcs31 ();
-                break;
-              default:
-                NS_ASSERT_MSG (false, "Invalid MCS encoded in HT-SIG header");
-                break;
-            }
-          txVector.SetMode (mode);
+          txVector.SetMode (WifiPhy::GetHtMcs (m_htSig.GetMcs ()));
           txVector.SetChannelWidth (m_htSig.GetChannelWidth ());
           txVector.SetNss (1 + (m_htSig.GetMcs () / 8));
           txVector.SetGuardInterval(m_htSig.GetShortGuardInterval () ? 400 : 800);
@@ -402,44 +299,7 @@
         }
       case WIFI_MOD_CLASS_VHT:
         {
-          WifiMode mode;
-          switch (m_vhtSig.GetSuMcs ())
-            {
-              case 0:
-                mode = WifiPhy::GetVhtMcs0 ();
-                break;
-              case 1:
-                mode = WifiPhy::GetVhtMcs1 ();
-                break;
-              case 2:
-                mode = WifiPhy::GetVhtMcs2 ();
-                break;
-              case 3:
-                mode = WifiPhy::GetVhtMcs3 ();
-                break;
-              case 4:
-                mode = WifiPhy::GetVhtMcs4 ();
-                break;
-              case 5:
-                mode = WifiPhy::GetVhtMcs5 ();
-                break;
-              case 6:
-                mode = WifiPhy::GetVhtMcs6 ();
-                break;
-              case 7:
-                mode = WifiPhy::GetVhtMcs7 ();
-                break;
-              case 8:
-                mode = WifiPhy::GetVhtMcs8 ();
-                break;
-              case 9:
-                mode = WifiPhy::GetVhtMcs9 ();
-                break;
-              default:
-                NS_ASSERT_MSG (false, "Invalid MCS encoded in VHT-SIG header");
-                break;
-            }
-          txVector.SetMode (mode);
+          txVector.SetMode (WifiPhy::GetVhtMcs (m_vhtSig.GetSuMcs ()));
           txVector.SetChannelWidth (m_vhtSig.GetChannelWidth ());
           txVector.SetNss (m_vhtSig.GetNStreams ());
           txVector.SetGuardInterval (m_vhtSig.GetShortGuardInterval () ? 400 : 800);
@@ -448,50 +308,7 @@
         }
       case WIFI_MOD_CLASS_HE:
         {
-          WifiMode mode;
-          switch (m_heSig.GetMcs ())
-            {
-              case 0:
-                mode = WifiPhy::GetHeMcs0 ();
-                break;
-              case 1:
-                mode = WifiPhy::GetHeMcs1 ();
-                break;
-              case 2:
-                mode = WifiPhy::GetHeMcs2 ();
-                break;
-              case 3:
-                mode = WifiPhy::GetHeMcs3 ();
-                break;
-              case 4:
-                mode = WifiPhy::GetHeMcs4 ();
-                break;
-              case 5:
-                mode = WifiPhy::GetHeMcs5 ();
-                break;
-              case 6:
-                mode = WifiPhy::GetHeMcs6 ();
-                break;
-              case 7:
-                mode = WifiPhy::GetHeMcs7 ();
-                break;
-              case 8:
-                mode = WifiPhy::GetHeMcs8 ();
-                break;
-              case 9:
-                mode = WifiPhy::GetHeMcs9 ();
-                break;
-              case 10:
-                mode = WifiPhy::GetHeMcs10 ();
-                break;
-              case 11:
-                mode = WifiPhy::GetHeMcs11 ();
-                break;
-              default:
-                NS_ASSERT_MSG (false, "Invalid MCS encoded in HE-SIG header");
-                break;
-            }
-          txVector.SetMode (mode);
+          txVector.SetMode (WifiPhy::GetHeMcs (m_heSig.GetMcs ()));
           txVector.SetChannelWidth (m_heSig.GetChannelWidth ());
           txVector.SetNss (m_heSig.GetNStreams ());
           txVector.SetGuardInterval (m_heSig.GetGuardInterval ());
@@ -539,10 +356,10 @@
           break;
       case WIFI_MOD_CLASS_OFDM:
       case WIFI_MOD_CLASS_ERP_OFDM:
-          ppduDuration = WifiPhy::CalculateTxDuration (m_lSig.GetLength (), txVector, m_frequency);
+          ppduDuration = WifiPhy::CalculateTxDuration (m_lSig.GetLength (), txVector, m_band);
           break;
       case WIFI_MOD_CLASS_HT:
-          ppduDuration = WifiPhy::CalculateTxDuration (m_htSig.GetHtLength (), txVector, m_frequency);
+          ppduDuration = WifiPhy::CalculateTxDuration (m_htSig.GetHtLength (), txVector, m_band);
           break;
       case WIFI_MOD_CLASS_VHT:
         {
@@ -562,7 +379,7 @@
           Time tSymbol = NanoSeconds (12800 + txVector.GetGuardInterval ());
           Time preambleDuration = WifiPhy::CalculatePhyPreambleAndHeaderDuration (txVector);
           uint8_t sigExtension = 0;
-          if (Is2_4Ghz (m_frequency))
+          if (m_band == WIFI_PHY_BAND_2_4GHZ)
             {
               sigExtension = 6;
             }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/wifi/model/wifi-ppdu.h ns-3.32/src/wifi/model/wifi-ppdu.h
--- ns-3.31/src/wifi/model/wifi-ppdu.h	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/wifi/model/wifi-ppdu.h	2020-10-06 15:35:43.000000000 -0700
@@ -25,6 +25,7 @@
 #include "ns3/nstime.h"
 #include "wifi-tx-vector.h"
 #include "wifi-phy-header.h"
+#include "wifi-phy-band.h"
 
 namespace ns3 {
 
@@ -45,9 +46,9 @@
    * \param psdu the PHY payload (PSDU)
    * \param txVector the TXVECTOR that was used for this PPDU
    * \param ppduDuration the transmission duration of this PPDU
-   * \param frequency the frequency used for the transmission of this PPDU
+   * \param band the WifiPhyBand used for the transmission of this PPDU
    */
-  WifiPpdu (Ptr<const WifiPsdu> psdu, WifiTxVector txVector, Time ppduDuration, uint16_t frequency);
+  WifiPpdu (Ptr<const WifiPsdu> psdu, WifiTxVector txVector, Time ppduDuration, WifiPhyBand band);
 
   virtual ~WifiPpdu ();
 
@@ -92,7 +93,7 @@
   WifiModulationClass m_modulation; //!< the modulation used for the transmission of this PPDU
   Ptr<const WifiPsdu> m_psdu;       //!< the PSDU contained in this PPDU
   bool m_truncatedTx;               //!< flag indicating whether the frame's transmission was aborted due to transmitter switch off
-  uint16_t m_frequency;             //!< the frequency used to transmit that PPDU in MHz
+  WifiPhyBand m_band;               //!< the WifiPhyBand used to transmit that PPDU
   uint16_t m_channelWidth;          //!< the channel width used to transmit that PPDU in MHz
   uint8_t m_txPowerLevel;           //!< the transmission power level (used only for TX and initializing the returned WifiTxVector)
 };
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/wifi/model/wifi-remote-station-manager.cc ns-3.32/src/wifi/model/wifi-remote-station-manager.cc
--- ns-3.31/src/wifi/model/wifi-remote-station-manager.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/wifi/model/wifi-remote-station-manager.cc	2020-10-06 15:35:43.000000000 -0700
@@ -26,7 +26,6 @@
 #include "wifi-remote-station-manager.h"
 #include "wifi-phy.h"
 #include "wifi-mac.h"
-#include "wifi-utils.h"
 #include "wifi-mac-header.h"
 #include "wifi-mac-trailer.h"
 #include "ht-configuration.h"
@@ -121,8 +120,7 @@
     m_useNonHtProtection (false),
     m_useGreenfieldProtection (false),
     m_shortPreambleEnabled (false),
-    m_shortSlotTimeEnabled (false),
-    m_rifsPermitted (false)
+    m_shortSlotTimeEnabled (false)
 {
   NS_LOG_FUNCTION (this);
 }
@@ -210,13 +208,6 @@
   m_shortSlotTimeEnabled = enable;
 }
 
-void
-WifiRemoteStationManager::SetRifsPermitted (bool allow)
-{
-  NS_LOG_FUNCTION (this << allow);
-  m_rifsPermitted = allow;
-}
-
 bool
 WifiRemoteStationManager::GetShortSlotTimeEnabled (void) const
 {
@@ -230,12 +221,6 @@
 }
 
 bool
-WifiRemoteStationManager::GetRifsPermitted (void) const
-{
-  return m_rifsPermitted;
-}
-
-bool
 WifiRemoteStationManager::GetHtSupported (void) const
 {
   Ptr<WifiNetDevice> device = DynamicCast<WifiNetDevice> (m_wifiPhy->GetDevice ());
@@ -1152,7 +1137,7 @@
   NS_LOG_FUNCTION (this << from << heCapabilities);
   WifiRemoteStationState *state;
   state = LookupState (from);
-  if (Is5Ghz (m_wifiPhy->GetFrequency ()))
+  if ((m_wifiPhy->GetPhyBand () == WIFI_PHY_BAND_5GHZ) || (m_wifiPhy->GetPhyBand () == WIFI_PHY_BAND_6GHZ))
     {
       if (heCapabilities.GetChannelWidthSet () & 0x04)
         {
@@ -1164,7 +1149,7 @@
         }
       //For other cases at 5 GHz, the supported channel width is set by the VHT capabilities
     }
-  else if (Is2_4Ghz (m_wifiPhy->GetFrequency ()))
+  else if (m_wifiPhy->GetPhyBand () == WIFI_PHY_BAND_2_4GHZ)
     {
       if (heCapabilities.GetChannelWidthSet () & 0x01)
         {
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/wifi/model/wifi-remote-station-manager.h ns-3.32/src/wifi/model/wifi-remote-station-manager.h
--- ns-3.31/src/wifi/model/wifi-remote-station-manager.h	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/wifi/model/wifi-remote-station-manager.h	2020-10-06 15:35:43.000000000 -0700
@@ -352,19 +352,6 @@
    *         false otherwise
    */
   bool GetShortSlotTimeEnabled (void) const;
-  /**
-   * Permit or prohibit RIFS.
-   *
-   * \param allow permit or prohibit RIFS
-   */
-  void SetRifsPermitted (bool allow);
-  /**
-   * Return whether the device can use RIFS.
-   *
-   * \return true if RIFS is permitted,
-   *         false otherwise
-   */
-  bool GetRifsPermitted (void) const;
 
   /**
    * Reset the station, invoked in a STA upon dis-association or in an AP upon reboot.
@@ -1288,7 +1275,6 @@
   bool m_useGreenfieldProtection; //!< flag if protection for stations that do not support HT Greenfield format is enabled
   bool m_shortPreambleEnabled;    //!< flag if short PHY preamble is enabled
   bool m_shortSlotTimeEnabled;    //!< flag if short slot time is enabled
-  bool m_rifsPermitted;           //!< flag if RIFS is enabled
   ProtectionMode m_erpProtectionMode; //!< Protection mode for ERP stations when non-ERP stations are detected
   ProtectionMode m_htProtectionMode;  //!< Protection mode for HT stations when non-HT stations are detected
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/wifi/model/wifi-standards.h ns-3.32/src/wifi/model/wifi-standards.h
--- ns-3.31/src/wifi/model/wifi-standards.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.32/src/wifi/model/wifi-standards.h	2020-10-06 15:35:43.000000000 -0700
@@ -0,0 +1,225 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2007 INRIA
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
+ */
+
+#ifndef WIFI_STANDARD_H
+#define WIFI_STANDARD_H
+
+#include <map>
+#include "wifi-phy-band.h"
+
+namespace ns3 {
+
+/**
+ * \ingroup wifi
+ * Identifies the PHY specification that a Wifi device is configured to use.
+ */
+enum WifiPhyStandard
+{
+  /** OFDM PHY (Clause 17) */
+  WIFI_PHY_STANDARD_80211a,
+  /** DSSS PHY (Clause 15) and HR/DSSS PHY (Clause 18) */
+  WIFI_PHY_STANDARD_80211b,
+  /** ERP-OFDM PHY (Clause 19, Section 19.5) */
+  WIFI_PHY_STANDARD_80211g,
+  /** OFDM PHY for the 5 GHz band (Clause 17 with 10 MHz channel bandwidth) */
+  /** this value is NS_DEPRECATED_3_32 */
+  WIFI_PHY_STANDARD_80211_10MHZ,
+  /** OFDM PHY for the 5 GHz band (Clause 17 with 5 MHz channel bandwidth) */
+  /** this value is NS_DEPRECATED_3_32 */
+  WIFI_PHY_STANDARD_80211_5MHZ,
+  /** OFDM PHY (Clause 17 - amendment for 10 MHz and 5 MHz channels) */
+  WIFI_PHY_STANDARD_80211p,
+  /** This is intended to be the configuration used in this paper:
+   *  Gavin Holland, Nitin Vaidya and Paramvir Bahl, "A Rate-Adaptive
+   *  MAC Protocol for Multi-Hop Wireless Networks", in Proc. of
+   *  ACM MOBICOM, 2001.
+   */
+  WIFI_PHY_STANDARD_holland,
+  /** HT PHY for the 2.4 GHz band (clause 20) */
+  /** this value is NS_DEPRECATED_3_32 */
+  WIFI_PHY_STANDARD_80211n_2_4GHZ,
+  /** HT PHY for the 5 GHz band (clause 20) */
+  /** this value is NS_DEPRECATED_3_32 */
+  WIFI_PHY_STANDARD_80211n_5GHZ,
+  /** HT PHY  (clause 20) */
+  WIFI_PHY_STANDARD_80211n,
+  /** VHT PHY (clause 22) */
+  WIFI_PHY_STANDARD_80211ac,
+  /** HE PHY (clause 26) */
+  WIFI_PHY_STANDARD_80211ax,
+  /** Unspecified */
+  WIFI_PHY_STANDARD_UNSPECIFIED
+};
+
+/**
+* \brief Stream insertion operator.
+*
+* \param os the stream
+* \param standard the PHY standard
+* \returns a reference to the stream
+*/
+inline std::ostream& operator<< (std::ostream& os, WifiPhyStandard standard)
+{
+  switch (standard)
+    {
+    case WIFI_PHY_STANDARD_80211a:
+      return (os << "802.11a");
+    case WIFI_PHY_STANDARD_80211b:
+      return (os << "802.11b");
+    case WIFI_PHY_STANDARD_80211g:
+      return (os << "802.11g");
+    case WIFI_PHY_STANDARD_80211p:
+      return (os << "802.11p");
+    case WIFI_PHY_STANDARD_holland:
+      return (os << "802.11a-holland");
+    case WIFI_PHY_STANDARD_80211n:
+      return (os << "802.11n");
+    case WIFI_PHY_STANDARD_80211ac:
+      return (os << "802.11ac");
+    case WIFI_PHY_STANDARD_80211ax:
+      return (os << "802.11ax");
+    case WIFI_PHY_STANDARD_UNSPECIFIED:
+    default:
+      return (os << "UNSPECIFIED");
+    }
+}
+
+/**
+ * \ingroup wifi
+ * Identifies the MAC specification that a Wifi device is configured to use.
+ */
+enum WifiMacStandard
+{
+  WIFI_MAC_STANDARD_80211,
+  WIFI_MAC_STANDARD_80211n,
+  WIFI_MAC_STANDARD_80211ac,
+  WIFI_MAC_STANDARD_80211ax
+};
+
+/**
+* \brief Stream insertion operator.
+*
+* \param os the stream
+* \param standard the MAC standard
+* \returns a reference to the stream
+*/
+inline std::ostream& operator<< (std::ostream& os, WifiMacStandard standard)
+{
+  switch (standard)
+    {
+    case WIFI_MAC_STANDARD_80211:
+      return (os << "802.11");
+    case WIFI_MAC_STANDARD_80211n:
+      return (os << "802.11n");
+    case WIFI_MAC_STANDARD_80211ac:
+      return (os << "802.11ac");
+    case WIFI_MAC_STANDARD_80211ax:
+      return (os << "802.11ax");
+    default:
+      return (os << "UNSPECIFIED");
+    }
+}
+
+/**
+ * \ingroup wifi
+ * Identifies the allowed configurations that a Wifi device is configured to use.
+ */
+enum WifiStandard
+{
+  WIFI_STANDARD_80211a,
+  WIFI_STANDARD_80211b,
+  WIFI_STANDARD_80211g,
+  WIFI_STANDARD_80211p,
+  WIFI_STANDARD_holland,
+  WIFI_STANDARD_80211n_2_4GHZ,
+  WIFI_STANDARD_80211n_5GHZ,
+  WIFI_STANDARD_80211ac,
+  WIFI_STANDARD_80211ax_2_4GHZ,
+  WIFI_STANDARD_80211ax_5GHZ,
+  WIFI_STANDARD_80211ax_6GHZ
+};
+
+/**
+* \brief Stream insertion operator.
+*
+* \param os the stream
+* \param standard the standard
+* \returns a reference to the stream
+*/
+inline std::ostream& operator<< (std::ostream& os, WifiStandard standard)
+{
+  switch (standard)
+    {
+    case WIFI_STANDARD_80211a:
+      return (os << "802.11a");
+    case WIFI_STANDARD_80211b:
+      return (os << "802.11b");
+    case WIFI_STANDARD_80211g:
+      return (os << "802.11g");
+    case WIFI_STANDARD_80211p:
+      return (os << "802.11p");
+    case WIFI_STANDARD_holland:
+      return (os << "802.11a-holland");
+    case WIFI_STANDARD_80211n_2_4GHZ:
+      return (os << "802.11n-2.4GHz");
+    case WIFI_STANDARD_80211n_5GHZ:
+      return (os << "802.11n-5GHz");
+    case WIFI_STANDARD_80211ac:
+      return (os << "802.11ac");
+    case WIFI_STANDARD_80211ax_2_4GHZ:
+      return (os << "802.11ax-2.4GHz");
+    case WIFI_STANDARD_80211ax_5GHZ:
+      return (os << "802.11ax-5GHz");
+    default:
+      return (os << "UNSPECIFIED");
+    }
+}
+
+/**
+ * \brief hold PHY and MAC information based on the selected standard.
+ */
+struct WifiStandardInfo
+{
+  WifiPhyStandard phyStandard;
+  WifiPhyBand phyBand;
+  WifiMacStandard macStandard;
+};
+
+/**
+ * \brief map a given standard configured by the user to the corresponding WifiStandardInfo
+ */
+const std::map<WifiStandard, WifiStandardInfo> wifiStandards =
+{
+  { WIFI_STANDARD_80211a, { WIFI_PHY_STANDARD_80211a, WIFI_PHY_BAND_5GHZ, WIFI_MAC_STANDARD_80211 } },
+  { WIFI_STANDARD_80211b, { WIFI_PHY_STANDARD_80211b, WIFI_PHY_BAND_2_4GHZ, WIFI_MAC_STANDARD_80211 } },
+  { WIFI_STANDARD_80211g, { WIFI_PHY_STANDARD_80211g, WIFI_PHY_BAND_2_4GHZ, WIFI_MAC_STANDARD_80211 } },
+  { WIFI_STANDARD_80211p, { WIFI_PHY_STANDARD_80211p, WIFI_PHY_BAND_5GHZ, WIFI_MAC_STANDARD_80211 } },
+  { WIFI_STANDARD_holland, { WIFI_PHY_STANDARD_holland, WIFI_PHY_BAND_5GHZ, WIFI_MAC_STANDARD_80211 } },
+  { WIFI_STANDARD_80211n_2_4GHZ, { WIFI_PHY_STANDARD_80211n, WIFI_PHY_BAND_2_4GHZ, WIFI_MAC_STANDARD_80211n } },
+  { WIFI_STANDARD_80211n_5GHZ, { WIFI_PHY_STANDARD_80211n, WIFI_PHY_BAND_5GHZ, WIFI_MAC_STANDARD_80211n } },
+  { WIFI_STANDARD_80211ac, { WIFI_PHY_STANDARD_80211ac, WIFI_PHY_BAND_5GHZ, WIFI_MAC_STANDARD_80211ac } },
+  { WIFI_STANDARD_80211ax_2_4GHZ, { WIFI_PHY_STANDARD_80211ax, WIFI_PHY_BAND_2_4GHZ, WIFI_MAC_STANDARD_80211ax } },
+  { WIFI_STANDARD_80211ax_5GHZ, { WIFI_PHY_STANDARD_80211ax, WIFI_PHY_BAND_5GHZ, WIFI_MAC_STANDARD_80211ax } },
+  { WIFI_STANDARD_80211ax_6GHZ, { WIFI_PHY_STANDARD_80211ax, WIFI_PHY_BAND_6GHZ, WIFI_MAC_STANDARD_80211ax } }
+};
+
+} //namespace ns3
+
+#endif /* WIFI_STANDARD_H */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/wifi/model/wifi-utils.cc ns-3.32/src/wifi/model/wifi-utils.cc
--- ns-3.31/src/wifi/model/wifi-utils.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/wifi/model/wifi-utils.cc	2020-10-06 15:35:43.000000000 -0700
@@ -55,18 +55,6 @@
   return 10.0 * std::log10 (ratio);
 }
 
-bool
-Is2_4Ghz (double frequency)
-{
-  return frequency >= 2400 && frequency <= 2500;
-}
-
-bool
-Is5Ghz (double frequency)
-{
-  return frequency >= 5000 && frequency <= 6000;
-}
-
 uint16_t
 ConvertGuardIntervalToNanoSeconds (WifiMode mode, const Ptr<WifiNetDevice> device)
 {
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/wifi/model/wifi-utils.h ns-3.32/src/wifi/model/wifi-utils.h
--- ns-3.31/src/wifi/model/wifi-utils.h	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/wifi/model/wifi-utils.h	2020-10-06 15:35:43.000000000 -0700
@@ -66,16 +66,6 @@
  */
 double RatioToDb (double ratio);
 /**
- * \param frequency the frequency to check
- * \return whether frequency is in the 2.4 GHz band
- */
-bool Is2_4Ghz (double frequency);
-/**
- * \param frequency the frequency to check
- * \return whether frequency is in the 5 GHz band
- */
-bool Is5Ghz (double frequency);
-/**
  * Convert the guard interval to nanoseconds based on the WifiMode.
  *
  * \param mode the WifiMode
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/wifi/test/block-ack-test-suite.cc ns-3.32/src/wifi/test/block-ack-test-suite.cc
--- ns-3.31/src/wifi/test/block-ack-test-suite.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/wifi/test/block-ack-test-suite.cc	2020-10-06 15:35:43.000000000 -0700
@@ -813,7 +813,7 @@
   phy.SetChannel (channel.Create ());
 
   WifiHelper wifi;
-  wifi.SetStandard (WIFI_PHY_STANDARD_80211a);
+  wifi.SetStandard (WIFI_STANDARD_80211a);
   wifi.SetAckPolicySelectorForAc (AC_BE, "ns3::ConstantWifiAckPolicySelector",
                                   "BaThreshold", DoubleValue (0.125));
   wifi.SetRemoteStationManager ("ns3::IdealWifiManager");
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/wifi/test/channel-access-manager-test.cc ns-3.32/src/wifi/test/channel-access-manager-test.cc
--- ns-3.31/src/wifi/test/channel-access-manager-test.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/wifi/test/channel-access-manager-test.cc	2020-10-06 15:35:43.000000000 -0700
@@ -148,6 +148,68 @@
  * \ingroup wifi-test
  * \ingroup tests
  *
+ * \brief ChannelAccessManager Stub
+ */
+class ChannelAccessManagerStub : public ChannelAccessManager
+{
+public:
+  ChannelAccessManagerStub ()
+  {
+  }
+  /**
+   * Set the Short Interframe Space (SIFS).
+   *
+   * \param sifs the SIFS duration
+   */
+  void SetSifs (Time sifs)
+  {
+    m_sifs = sifs;
+  }
+  /**
+   * Set the slot duration.
+   *
+   * \param slot the slot duration
+   */
+  void SetSlot (Time slot)
+  {
+    m_slot = slot;
+  }
+  /**
+   * Set the duration of EIFS - DIFS
+   *
+   * \param eifsNoDifs the duration of EIFS - DIFS
+   */
+  void SetEifsNoDifs (Time eifsNoDifs)
+  {
+    m_eifsNoDifs = eifsNoDifs;
+  }
+
+private:
+  // Inherited from base class
+  Time GetSifs (void) const
+  {
+    return m_sifs;
+  }
+
+  Time GetSlot (void) const
+  {
+    return m_slot;
+  }
+
+  Time GetEifsNoDifs (void) const
+  {
+    return m_eifsNoDifs;
+  }
+
+  Time m_slot;        // slot duration
+  Time m_sifs;        // SIFS duration
+  Time m_eifsNoDifs;  // EIFS duration minus a DIFS
+};
+
+/**
+ * \ingroup wifi-test
+ * \ingroup tests
+ *
  * \brief Channel Access Manager Test
  */
 template <typename TxopType>
@@ -325,7 +387,7 @@
   typedef std::vector<Ptr<TxopTest<TxopType>>> TxopTests; //!< the TXOP tests typedef
 
   Ptr<MacLowStub> m_low; //!< the MAC low stubbed
-  Ptr<ChannelAccessManager> m_ChannelAccessManager; //!< the channel access manager
+  Ptr<ChannelAccessManagerStub> m_ChannelAccessManager; //!< the channel access manager
   TxopTests m_txop; //!< the vector of Txop test instances
   uint32_t m_ackTimeoutValue; //!< the Ack timeout value
 };
@@ -531,10 +593,8 @@
 void
 ChannelAccessManagerTest<TxopType>::StartTest (uint64_t slotTime, uint64_t sifs, uint64_t eifsNoDifsNoSifs, uint32_t ackTimeoutValue)
 {
-  m_ChannelAccessManager = CreateObject<ChannelAccessManager> ();
+  m_ChannelAccessManager = CreateObject<ChannelAccessManagerStub> ();
   m_low = CreateObject<MacLowStub> ();
-  m_low->SetSlotTime (MicroSeconds (slotTime));
-  m_low->SetSifs (MicroSeconds (sifs));
   m_ChannelAccessManager->SetupLow (m_low);
   m_ChannelAccessManager->SetSlot (MicroSeconds (slotTime));
   m_ChannelAccessManager->SetSifs (MicroSeconds (sifs));
